#somians chess game visualizer for maya
#free to use, please give me credit when you forward the script
#copyright 2011 by Ari Romano Pfefferkorn, stuff@somian.net
import maya.cmds as maya
def movepiece(xdest,ydest):
	global frame
	#first step
	frame+=speed/2
	maya.setKeyframe()
	maya.currentTime(frame)
	maya.move(0,5,0,r=True)
	maya.setKeyframe()
	#second step
	frame+=speed
	maya.currentTime(frame) 
	maya.move(xdest+moveoffset,0,0-ydest-moveoffset)
	maya.move(0,5,0,r=True)	
	maya.setKeyframe()
	#third step
	frame+=speed/2
	maya.currentTime(frame) 
	maya.move(xdest+moveoffset,0,0-ydest-moveoffset)
	maya.setKeyframe()
#set animation properties
capturerow=24
fieldwidth=3.00
moveoffset=fieldwidth/2
speed=10 #the number of frames for every move
pause=30 #the number of frames the opponents are "thinking"
#set-up
#field notation:
#[a-h],[1-8]
a=0
b=1
c=2
d=3
e=4
f=5
g=6
h=7
board=[1,2,3,4,5,6,7,8]

board[a]=["rw1","pw1","NULL","NULL","NULL","NULL","pb1","rb1"]
board[b]=["kw1","pw2","NULL","NULL","NULL","NULL","pb2","kb1"]
board[c]=["bw1","pw3","NULL","NULL","NULL","NULL","pb3","bb1"]
board[d]=["qw","pw4","NULL","NULL","NULL","NULL","pb4","kib"]
board[e]=["kiw","pw5","NULL","NULL","NULL","NULL","pb5","qb"]
board[f]=["bw2","pw6","NULL","NULL","NULL","NULL","pb6","bb2"]
board[g]=["kw2","pw7","NULL","NULL","NULL","NULL","pb7","kb2"]
board[h]=["rw2","pw8","NULL","NULL","NULL","NULL","pb8","rb2"]
#read game data
#kasparov vs. deep blue:
game=["e2e4","c7c6","d2d4","d7d5","b1c3","d5e4","c3e4","b8d7","e4g5","g8f6","f1d3","e7e6","g1f3","h7h6","g5e6","d8e7","e1g1","f7e6","d3g6","e8d8","c1f4","b7b5","a2a4","c8b7","f1e1","f6d5","f4g3","d8c8","a4b5","c6b5","d1d3","b7c6","g6f5","e6f5","e1e7","f8e7","c2c4"]
frame=1
def launch():
    print game
    #animation setup:
    #begin at the first frame
    maya.currentTime(0)

    #create animation
    #main loop
    move=1
    while(move<=len(game)):
        print("——— move "+str(move)+" ("+str(game[move-1])+"):")
        str(game[move-1])
        #generally advance in time
        frame+=pause
        print("starts at frame "+str(frame))
        #compute target position
        fdest=game[move-1][2]
        if fdest == "a":
            xdest = a
        elif fdest == "b":
            xdest = b
        elif fdest == "c":
            xdest = c
        elif fdest == "d":
            xdest = d
        elif fdest == "e":
            xdest = e
        elif fdest == "f":
            xdest = f
        elif fdest == "g":
            xdest = g
        elif fdest == "h":
            xdest = h
        ydest = int(game[move-1][3])-1
        print("to "+str(xdest)+", "+str(ydest)+" (logically)")
        xdestf=int(xdest)*fieldwidth
        ydestf=int(ydest)*fieldwidth
        print("to "+str(xdestf)+", "+str(ydestf)+" (visually)")
        #select piece
        forg=game[move-1][0]
        if forg == "a":
            xorg=a
        elif forg == "b":
            xorg = b
        elif forg == "c":
            xorg = c
        elif forg == "d":
            xorg = d
        elif forg == "e":
            xorg = e
        elif forg == "f":
            xorg = f
        elif forg == "g":
            xorg = g
        elif forg == "h":
            xorg = h
        yorg=int(game[move-1][1])-1
        print("moving piece from "+str(xorg)+", "+str(yorg))
        #check if there's a piece on the field and, if yes, select it
        if board[xorg][yorg]!="NULL":
            maya.select(board[xorg][yorg])
        #move piece visually
        movepiece(xdestf,ydestf)

        #if there's another piece on the destination square, capture it
        ydest=int(ydest)
        if board[xdest][ydest]!="NULL":
            #capture the piece
            maya.select(board[xdest][ydest])
            movepiece(-5,capturerow)
            capturerow-=fieldwidth
        else:
            frame+=speed
            maya.currentTime(frame) #advance in time
        #castling
        if board[xorg][yorg]=="kiw" or board[xorg][yorg]=="kib":
            if	xdest-xorg!=1 or xorg-xdest!=-1:
                print("castling detected")
                if board[xorg][yorg]=="kiw" and xdest<xorg:
                    maya.select("rw1")
                    xdestf=int(xdest+1)*fieldwidth
                    ydestf=int(ydest)*fieldwidth
                    movepiece(xdestf,ydestf)
                    #logic
                    board[xdest+1][ydest]="rw1"
                    print("rook placed on"+str(xdest+1)+", "+str(ydest))
                    board[a][0]="NULL"
                elif board[xorg][yorg]=="kiw" and xdest>xorg:
                    maya.select("rw2")
                    xdestf=int(xdest-1)*fieldwidth
                    ydestf=int(ydest)*fieldwidth
                    movepiece(xdestf,ydestf)
                    #logic
                    board[xdest-1][ydest]="rw2"
                    print("rook placed on"+str(xdest+1)+", "+str(ydest))
                    board[h][0]="NULL"
                elif board[xorg][yorg]=="kib" and xdest<xorg:
                    maya.select("rb1")
                    xdestf=int(xdest+1)*fieldwidth
                    ydestf=int(ydest)*fieldwidth
                    movepiece(xdestf,ydestf)
                    #logic
                    board[xdest+1][ydest]="rb1"
                    print("rook placed on"+str(xdest+1)+", "+str(ydest))
                    board[a][7]="NULL"
                elif board[xorg][yorg]=="kib" and xdest>xorg:
                    maya.select("rb2")
                    xdestf=int(xdest-1)*fieldwidth
                    ydestf=int(ydest)*fieldwidth
                    movepiece(xdestf,ydestf)
                    #logic
                    board[xdest+1][ydest]="rb2"
                    print("rook placed on"+str(xdest+1)+", "+str(ydest))
                    board[h][7]="NULL"
                else:
                    print("this is not supposed to happen…")
        #move piece logically
        board[xdest][ydest]=board[xorg][yorg]
        board[xorg][yorg]="NULL"
        print("ends at frame "+str(frame))
        #end of move
        move+=1
    #adjust the length of the animation to the length of the chess game
    maya.playbackOptions(max=frame)
#jump back to frame 1. ready to play the animation!
#maya.currentTime(0)

launch()